package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.feature.Feature;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureLocator;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureMetaInfo;

import java.util.Iterator;
import java.util.List;

public abstract class BaseFeatureLocator implements FeatureLocator
{
	@Override
	public List<Feature> getFeatures(feature_type type)
	{
		List<Feature> list = getFeatures();

		if (type != feature_type.all)
		{
			Iterator<Feature> it = list.iterator();

			while (it.hasNext())
			{
				Feature feature = it.next();

				FeatureMetaInfo metaInfo = feature.getMetaInfo();

				switch (type)
				{
					case internal:
						if (!metaInfo.isInternalFeature())
						{
							it.remove();
						}
						break;
					case external:
						if (metaInfo.isInternalFeature())
						{
							it.remove();
						}
						break;
				}
			}
		}

		return list;
	}
}